// B737-800X_3_36_fullでロータリースイッチ動作を確認した
// 中国製Baosity Teensy++2.0チップ　Macでは書き込みエラーになるので、必ずWindowsから書き込むこと。
  #include <LedControl.h>
  #include <Bounce.h>
  #include <Encoder.h>
  #include <Wire.h> 
  #include <LiquidCrystal_I2C.h>  //中国製I2C
  
  #define BUTTON 22
  const int ledPin = 5;
  
    //------I2C & 7seg 共通--------------
    enum pins {
      ModeSwitchPin_A1 = 42,  //I2C
      ModeSwitchPin_A2 = 41,  //I2C
      ModeSwitchPin_B1 = 39,  //7seg
      ModeSwitchPin_B2 = 40,  //7seg
      ModeSwitchPin_B3 = 38,  //7seg
      Nav1_LED = 6,  //7seg
      Com1_LED = 7  //7seg
    };  //最後の；は必要
    
    //モードのこと
    Bounce modeSwitch_A1 = Bounce (ModeSwitchPin_A1, 5);  //I2C
    Bounce modeSwitch_A2 = Bounce (ModeSwitchPin_A2, 5);  //I2C
    Bounce modeSwitch_A3 = Bounce (ModeSwitchPin_A2, 5);  //I2C
    Bounce modeSwitch_B1 = Bounce (ModeSwitchPin_B1, 5);  //7seg
    Bounce modeSwitch_B2 = Bounce (ModeSwitchPin_B2, 5);  //7seg
    Bounce modeSwitch_B3 = Bounce (ModeSwitchPin_B2, 5);  //7seg
    Bounce modeSwitch_B4 = Bounce (ModeSwitchPin_B3, 5);  //7seg
    
    FlightSimFloat Airspeed_kts;  //Floatで小数点以下も扱える、本来フロート  //I2C
    FlightSimFloat Altitude_ft;  //Floatで小数点以下も扱える、本来フロート  //I2C
    //FlightSimFloat Fuel_flow;
    FlightSimInteger Fuel_Total;
    FlightSimInteger Fuel_left;
    FlightSimInteger Fuel_center;
    FlightSimInteger Fuel_right;
    FlightSimInteger Nav1_Val;
    FlightSimInteger Com1_Val;
    FlightSimInteger Transponder_Val;
    //------I2C & 7seg end--------------
  
    /////////////////////////////////////////////////////////////////////////
    //--- i2C LCD1602 宣言 ----------------------------
    /////////////////////////////////////////////////////////////////////////
    LiquidCrystal_I2C lcd(0x27, 16, 2); // I2C: 0x3F, 16x2 LCDを16文字で2行表示。
     enum Modes_A1 {
      Mode_SwitchA1, // automatically = 0
      Mode_SwitchA2, // automatically = 1
      Mode_Count_A1 // automagically = 2, and we have 2 modes, that's convenient!
    };
    int mode_A1 = 0;
    
    enum Modes_A2 {
      Mode_Airspeed_kts, // automatically = 0
      Mode_Altitude_ft, // automatically = 1
      Mode_Count_A2 // automagically = 2, and we have 2 modes, that's convenient!
    };
    int mode_A2 = 0;
    
    enum Modes_A3 {
      Mode_Fuel_flow, // automatically = 0
      Mode_Fuel_flow_2, // automatically = 1
      Mode_Count_A3 // automagically = 2, and we have 2 modes, that's convenient!
    };
    int mode_A3 = 0;
    //--------- i2C LCD1602 END ----------------

    //--------- ロータリースイッチ ----------------
    /////////////////////////////////////////////////////////////////////////
    //--- CTR ロータリー SW（左側）宣言 ----------------------------
    /////////////////////////////////////////////////////////////////////////
    const int CTR_Rotary_firstPin = 8;  //ロータリースイッチの最初のピン
    const int CTR_Rotary_2Pin = 9;  
    const int CTR_Rotary_3Pin = 10;  
    const int CTR_Rotary_lastPin = 11;  //ロータリースイッチの最後のピン
    FlightSimInteger CTR_RangeSelector;
    
    /////////////////////////////////////////////////////////////////////////
    //--- TFC ロータリー SW（右側）宣言 ----------------------------
    /////////////////////////////////////////////////////////////////////////
    //8ピンもあるが実際のB737では動作していないので空スイッチになる
    const int TFC_Rotary_firstPin = 12;  //ロータリースイッチの最初のピン9-8
    const int TFC_Rotary_2Pin = 13;
    const int TFC_Rotary_3Pin = 14;
    const int TFC_Rotary_4Pin = 15;
    const int TFC_Rotary_5Pin = 16;
    const int TFC_Rotary_6Pin = 17;
    const int TFC_Rotary_7Pin = 18;
    const int TFC_Rotary_lastPin = 19;  //ロータリースイッチの最後のピン16-15
    FlightSimInteger TFC_RangeSelector;
    //--------- ロータリースイッチ END ----------------
    
    
    /////////////////////////////////////////////////////////////////////////
    //--- LED 74HC595 シフトレジスタ 共通 -------------------
    /////////////////////////////////////////////////////////////////////////
    int SER_dataPin = 43;   //75HC595のピン14（SER）とUNOの8ピンを繋ぐ（DS-data）21
    int RCLK_latchPin = 44;  //75HC595のピン12（RCLK）とUNOの9ピンを繋ぐ（ST_CP-latch）24
    int SRCLK_clockPin = 45; //75HC595のピン11（SRCLK）とUNOの10ピンを繋ぐ（SH_CP-clock）23
     
    //How many of the shift registers - change this
    #define number_of_74hc595s 2  //シフトレジスタの数（７４HC５９５の設置数）
     
    //do not touch
    #define numOfRegisterPins number_of_74hc595s * 8  //ここは触れないでください
     
    boolean registers[numOfRegisterPins];    //上のレジスタの数を反映させる
    //--------- LED 74HC595 シフトレジスタ END ----------------------------------------------
  
    /////////////////////////////////////////////////////////////////////////
    //--- LED 74HC595 シフトレジスタ ----------------------------
    /////////////////////////////////////////////////////////////////////////

    /////////// 逆噴射 LED シフトレジスタ（74HC595） -----------
    const int Reverser_74HC595_Pin = 0;
    FlightSimInteger ReverserSwLED;  //74HC595（LED）接続

    /////////// スピードブレーキ LED シフトレジスタ（74HC595）-----------
    const int SpeedBrake_74HC595_Pin = 1;
    FlightSimInteger SpeedBrakeSwLED;

    /////////// パーキングブレーキ LED シフトレジスタ（74HC595）-----------
    const int ParkingBrake_74HC595_Pin = 2;
    FlightSimFloat ParkingBrakeSwLED;

    /////////// ギア LED シフトレジスタ（74HC595）-----------
    const int GearHandole_74HC595_Pin = 3;
    FlightSimInteger GearHandleLED;
    //FlightSimInteger GearSwLED; 
 
    /////////// ビーコン　ライト LED シフトレジスタ（74HC595）B777専用 -----------
    const int BeaconBrightness_74HC595_Pin = 4;
    FlightSimFloat BeaconBrightnessLED;
 
    /////////// ストロボ　ライト LED シフトレジスタ（74HC595）-----------
    const int StorobeLight_74HC595_Pin = 5;
    FlightSimInteger StorobeLightLED;

    /////////// ウイング　ライト LED シフトレジスタ（74HC595）-----------
    const int WingLight_74HC595_Pin = 6;
    FlightSimInteger WingLightLED;

    /////////// ロゴ　ライト LED シフトレジスタ（74HC595）-----------
    const int LogoLight_74HC595_Pin = 7;
    FlightSimInteger LogoLightLED;

    /////////// ランディング　ライト LED シフトレジスタ（74HC595）-----------
    const int LandingLight_RETRACTABLE_74HC595_Pin = 8;
    FlightSimInteger LandingLight_RETRACTABLE_LED;

    /////////// Taxi　ライト LED シフトレジスタ（74HC595）-----------
    const int TaxiLight_74HC595_Pin = 10;
    FlightSimFloat TaxiLightLED;

    /////////// Runway Turnoff　ライト LED シフトレジスタ（74HC595）-----------
    const int RunwayTurnoff_Left_74HC595_Pin = 9;
    FlightSimInteger RunwayTurnoff_LeftLightLED;
    const int RunwayTurnoff_Right_74HC595_Pin = 11;
    FlightSimInteger RunwayTurnoff_RightLightLED;
    
    /////////// 7セグ切り替え用 LED シフトレジスタ（74HC595）-----------
    const int LeftLED_74HC595_Pin = 12;
    const int RightLED_74HC595_Pin = 13;
    
    //--------- LED 74HC595 シフトレジスタ END ------------------------------------------------------------
    

    /////////////////////////////////////////////////////////////////////////
    //--- 7セグメント ----------------------------
    /////////////////////////////////////////////////////////////////////////
    
    const int lc_DIN_Pin = 2;    //7セグ、teensyピン位置  18
    const int lc_CLK_Pin = 4; //19
    const int lc_LOAD_Pin = 3; //20
 
    //入力：DINピン、CLK端子、LOAD端子、チップ数（MAX7219の数）
    LedControl lc = LedControl(lc_DIN_Pin, lc_CLK_Pin, lc_LOAD_Pin, 1);
    
    enum Modes_1 {
      Mode_Switch1, // automatically = 0
      Mode_Switch2, // automatically = 1
      Mode_Count_1 // automagically = 2, and we have 2 modes, that's convenient!
    };  //最後の；は必要
    int mode_1 = 0;
    
    enum Modes_2 {
      Mode_Nav1, // automatically = 0
      Mode_Com1, // automatically = 1
      Mode_Count_2 // automagically = 2, and we have 2 modes, that's convenient!
    };  //最後の；は必要
    int mode_2 = 0;
    
    enum Modes_3 {
      Mode_Airspeed, // automatically = 0
      Mode_Altitude, // automatically = 1
      Mode_Count_3 // automagically = 2, and we have 2 modes, that's convenient!
    };  //最後の；は必要
    int mode_3 = 0;
  
    //--------- 7セグメント END ------------------------------------------------------------
    
  
    
    
  
  
  
  

void setup() {
    pinMode(ledPin, OUTPUT);
  
    pinMode(BUTTON, INPUT_PULLUP);
    //------setup I2C & 7seg 共通--------------
    pinMode(ModeSwitchPin_A1, INPUT_PULLUP);   //I2C
    pinMode(ModeSwitchPin_A2, INPUT_PULLUP);   //I2C
    pinMode(ModeSwitchPin_B1, INPUT_PULLUP);    //7seg
    pinMode(ModeSwitchPin_B2, INPUT_PULLUP);    //7seg
    
  
    pinMode(Nav1_LED, OUTPUT);    //7seg
    pinMode(Com1_LED, OUTPUT);    //7seg
    
    
    Airspeed_kts = XPlaneRef("sim/cockpit2/gauges/indicators/airspeed_kts_pilot");   //I2C
    Altitude_ft = XPlaneRef("sim/cockpit2/gauges/indicators/altitude_ft_pilot");   //I2C
    Fuel_Total = XPlaneRef("sim/flightmodel/weight/m_fuel_total");   //I2C datarefの数値はkg
    Fuel_left= XPlaneRef("sim/flightmodel/weight/m_fuel1");
    Fuel_center= XPlaneRef("sim/flightmodel/weight/m_fuel2");
    Fuel_right= XPlaneRef("sim/flightmodel/weight/m_fuel3");
    
    Nav1_Val = XPlaneRef("sim/cockpit2/radios/actuators/nav1_frequency_hz");    //7seg
    Com1_Val = XPlaneRef("sim/cockpit2/radios/actuators/com1_frequency_hz");    //7seg
    Transponder_Val = XPlaneRef("sim/cockpit2/radios/actuators/transponder_code");    //7seg
    
    //------setup I2C & 7seg 共通 end--------------
  
    /////////////////////////////////////////////////////////////////////////
    //--- setup内　I2C LCD1602 ----------------------------
    /////////////////////////////////////////////////////////////////////////
    lcd.init();
    lcd.backlight();
    //lcd.noBacklight();
   //--------- setup内　i2C LCD1602 END ------------------------------------------------------------
    
    
    
    
    //--------- setup内　74HC595 シフトレジスタ 共通 END ------------------------------------------------------------
    
    //--------- setup内　ロータリー SW ------------------------------------------------------------  
    //===============================================================================================
    /////////// setup内　CTR ロータリー SW（左側）//////////////////
    //===============================================================================================
    pinMode(CTR_Rotary_firstPin, INPUT_PULLUP);  // 接続モード
    pinMode(CTR_Rotary_2Pin, INPUT_PULLUP);
    pinMode(CTR_Rotary_3Pin, INPUT_PULLUP);
    pinMode(CTR_Rotary_lastPin, INPUT_PULLUP); 
    CTR_RangeSelector = XPlaneRef("laminar/B738/EFIS_control/capt/map_mode_pos");
    //===============================================================================================
    /////////// setup内　TFC ロータリー SW（右側）//////////////////
    //===============================================================================================
    pinMode(TFC_Rotary_firstPin, INPUT_PULLUP);  // 接続モード
    pinMode(TFC_Rotary_2Pin, INPUT_PULLUP);
    pinMode(TFC_Rotary_3Pin, INPUT_PULLUP);
    pinMode(TFC_Rotary_4Pin, INPUT_PULLUP);
    pinMode(TFC_Rotary_5Pin, INPUT_PULLUP);
    pinMode(TFC_Rotary_6Pin, INPUT_PULLUP);
    pinMode(TFC_Rotary_7Pin, INPUT_PULLUP);
    pinMode(TFC_Rotary_lastPin, INPUT_PULLUP); 
    TFC_RangeSelector = XPlaneRef("laminar/B738/EFIS/capt/map_range");
    //--------- setup内　ロータリー SW END ------------------------------------------------------------
    
    /////////////////////////////////////////////////////////////////////////
    //--- setup内　4HC595 LED シフトレジスタ ----------------------------
    /////////////////////////////////////////////////////////////////////////
    
    /////////// setup内　逆噴射 LED シフトレジスタ（74HC595）-----------
    ReverserSwLED = XPlaneRef("laminar/B738/engine/prop_mode_sync");
       ReverserSwLED.onChange(updateReverserSwLED);

    /////////// setup内　スピードブレーキ LED シフトレジスタ（74HC595）-----------
    SpeedBrakeSwLED = XPlaneRef("sim/cockpit2/controls/speedbrake_ratio");
      SpeedBrakeSwLED.onChange(updateSpeedBrakeSwLED);

    /////////// setup内　パーキングブレーキ LED シフトレジスタ（74HC595）-----------
    ParkingBrakeSwLED = XPlaneRef("sim/cockpit2/controls/parking_brake_ratio");
      ParkingBrakeSwLED.onChange(updateParkingBrakeSwLED);

    /////////// setup内　ギア LED シフトレジスタ（74HC595）-----------
    // ギアが動作している間のみ ON（1になる）
    GearHandleLED = XPlaneRef("sim/cockpit/switches/gear_handle_status");
      GearHandleLED.onChange(updateGearHandoleLED);

    /////////// setup内　ビーコン　ライト LED シフトレジスタ（74HC595）-----------
    BeaconBrightnessLED = XPlaneRef("sim/flightmodel2/lights/beacon_brightness_ratio[0]");
      BeaconBrightnessLED.onChange(updateBeaconBrightnessLED);

    /////////// setup内　ストロボ　ライト LED（74HC595）-----------
    StorobeLightLED = XPlaneRef("sim/flightmodel2/lights/strobe_flash_now");
      StorobeLightLED.onChange(updateStorobeLightLED);

    /////////// setup内　ウイング　ライト LED シフトレジスタ（74HC595）-----------
    WingLightLED = XPlaneRef("sim/cockpit2/switches/generic_lights_switch[0]");  //間違いない
      WingLightLED.onChange(updateWingLightLED);

    /////////// setup内　ロゴ　ライト LED シフトレジスタ（74HC595）-----------
    LogoLightLED = XPlaneRef("sim/cockpit2/switches/generic_lights_switch[1]");
      LogoLightLED.onChange(updateLogoLightLED);

    /////////// setup内　ランディング　ライト LED シフトレジスタ（74HC595）-----------
    //実際は3つのスイッチがあるが1つのスイッチで全てを点灯
    LandingLight_RETRACTABLE_LED = XPlaneRef("sim/cockpit2/switches/landing_lights_on");
      LandingLight_RETRACTABLE_LED.onChange(updateLandingLight_RETRACTABLE_LED);

    /////////// setup内　Taxi　ライト LED シフトレジスタ（74HC595）-----------
    TaxiLightLED = XPlaneRef("sim/cockpit2/switches/generic_lights_switch[4]");
      TaxiLightLED.onChange(updateTaxiLightLED);

    /////////// setup内　Runway Turnoff　ライト LED シフトレジスタ（74HC595）-----------
    RunwayTurnoff_LeftLightLED = XPlaneRef("sim/cockpit2/switches/generic_lights_switch[2]");
      RunwayTurnoff_LeftLightLED.onChange(updateRunwayTurnoff_LeftLightLED);
  
    RunwayTurnoff_RightLightLED = XPlaneRef("sim/cockpit2/switches/generic_lights_switch[3]");
      RunwayTurnoff_RightLightLED.onChange(updateRunwayTurnoff_RightLightLED);
    
    //--------- setup内　74HC595 シフトレジスタ END ------------------------------------------------------------

    /////////////////////////////////////////////////////////////////////////
    //--- setup内　7セグメント ----------------------------
    ///////////////////////////////////////////////////////////////////////// 
    lc.shutdown(0, false);  // turns on display
    lc.setIntensity(0, 5); // 15 = brightest 

    /////////////////////////////////////////////////////////////////////////
    // setup内　74HC595 LED シフトレジスタ 共通
    ///////////////////////////////////////////////////////////////////////// 
    pinMode(SER_dataPin, OUTPUT);
    pinMode(RCLK_latchPin, OUTPUT);
    pinMode(SRCLK_clockPin, OUTPUT);
    
}

void loop() {
    //--------- loop内共通----------------
    FlightSim.update();
    if (FlightSim.isEnabled()) {          //X-Planeが完全に起動し、データの出力が有効になったら。
     digitalWrite(ledPin, HIGH);  //tensy1ピン
    } else {
     digitalWrite(ledPin, HIGH);
     delay(1000); 
     digitalWrite(ledPin, LOW);
     delay(1000); 
   }
     
    //--------- loop内共通 END ------------------------------------------------------------
    
    //モードを切り替えするときのLEDアクション
    //digitalWrite(HdgModeLED, (mode == Mode_Heading));
    //digitalWrite(ElevTrimLED, (mode == Mode_ElevTrim));
   
    //writeRegisters();  //変更内容を表示するために呼び出さなければなりません
    //必要な値が設定された後に一度だけ呼び出します。
   
    //===============================================================================================
    /////////// loop内　i2C LCD1602 //////////////////
    //===============================================================================================
    modeSwitch_A1.update();
    modeSwitch_A2.update();
    modeSwitch_A3.update();
    
    // スイッチが押されたときにモードを変更する
    if(modeSwitch_A1.fallingEdge()) {
      ++mode_A1;
      if(mode_A1 >= Mode_Count_A1)
        mode_A1 = 0;
    }
    
    if(modeSwitch_A2.fallingEdge()) {
      ++mode_A2;
      if(mode_A2 >= Mode_Count_A2)
        mode_A2 = 0;
    }
    
    if(modeSwitch_A3.fallingEdge()) {
      ++mode_A3;
      if(mode_A3 >= Mode_Count_A3)
        mode_A3 = 0;
    }
    
    
    //上のスイッチが最初に押されたら
    if (mode_A1 == Mode_SwitchA1) {    
       if (mode_A3 == Mode_Fuel_flow) {    //上のスイッチが最初に押されたら、これが表示される。
         //1行目
          lcd.setCursor(0, 0);  //0は先頭から、2番目の0は1行目に表示
          lcd.print(Fuel_left * 2.2046, 0);  //最後の「1」は小数点以下の桁数である。この0は表示しないということになる。
          lcd.print("    ");
          
          lcd.setCursor(5, 0);  //5は文字を先頭から6番目に表示、2番目の0は1行目に表示
          lcd.print(Fuel_center * 2.2046, 0);
          lcd.print("     ");
     
          lcd.setCursor(11, 0);  //11は文字を先頭から6番目に表示、2番目の0は1行目に表示
          lcd.print(Fuel_right * 2.2046, 0);
          lcd.print("    ");
         
          //2行目
          lcd.setCursor(0, 1);  //0は先頭から、1は2行目に表示
          lcd.print("Total:");  //先頭の文字
          lcd.print(Fuel_Total * 2.2046, 0);  //最後の「1」は小数点以下の桁数である。この0は表示しないということになる。
          
          lcd.setCursor(14, 1);  //11は文字を先頭から6番目に表示、2番目の0は1行目に表示
          lcd.print("lb");
      
      }
      else if (mode_A3 == Mode_Fuel_flow_2) {    //下のスイッチが押されたら
          lcd.setCursor(0, 0);  //0は先頭から、2番目の0は1行目に表示
          lcd.print(Fuel_left, 1);  //最後の「1」は小数点以下の桁数である。この0は表示しないということになる。
          lcd.print("    ");

          lcd.setCursor(5, 0);  //5は文字を先頭から6番目に表示、2番目の0は1行目に表示
          lcd.print(Fuel_center , 1);
          lcd.print("    ");
          
          lcd.setCursor(10, 0);  //11は文字を先頭から10番目に表示、2番目の0は1行目に表示
          lcd.print(Fuel_right , 1);
          lcd.print("     ");
   
          lcd.setCursor(0, 1);  //0は先頭から、1は2行目に表示
          lcd.print("Total:");  //先頭の文字
          lcd.print(Fuel_Total, 1);  //最後の「1」は小数点以下の桁数である。この0は表示しないということになる。
          
          lcd.setCursor(14, 1);  //11は文字を先頭から6番目に表示、2番目の0は1行目に表示
          lcd.print("kg");
      }
      else{
          lcd.clear();  //これで切り替えのとき、前のデータをクリアできるので文字が重ならない。
      }
      
      
    }
    //これが起動画面。
    if (mode_A1 == Mode_SwitchA2) {    //下のスイッチが2番目に押されたら
      if (mode_A2 == Mode_Airspeed_kts) {
        //これが最初に表示される。
          lcd.setCursor(0, 0);  //0は先頭から、2番目の0は1行目に表示
          lcd.print("ArSpd:");  //先頭の文字
          lcd.print(Airspeed_kts, 1);  //最後の「1」は小数点以下の桁数である。この0は表示しないということになる。
          lcd.print("    ");
          
          lcd.setCursor(12, 0);  //13は先頭から12文字目から表示、2番目の0は1行目に表示
          lcd.print(" knt");
          
          lcd.setCursor(0, 1);  //0は先頭から、1は2行目に表示
          lcd.print("ALT:");  //先頭の文字
          lcd.print(Altitude_ft, 1);  //最後の「1」は小数点以下の桁数である。この0は表示しないということになる。
          
          lcd.setCursor(14, 1);  //0は先頭から、2番目の1は2行目に表示
          lcd.print("ft");
      }
    //下のボタンを押したら最初に表示される（つまり2番目）。
      else if (mode_A2 == Mode_Altitude_ft) {
          lcd.setCursor(0, 0);  //0は先頭から、2番目の0は1行目に表示
          lcd.print("ArSpd:");  //先頭の文字
          lcd.print(Airspeed_kts*1.8519984, 1);  //最後の「1」は小数点以下の桁数である。この0は表示しないということになる。
          lcd.print("   ");
          
          lcd.setCursor(12, 0);  //14は先頭から13文字目から表示、2番目の0は1行目に表示
          lcd.print("km/h");
          
          lcd.setCursor(0, 1);  //0は先頭から、1は2行目に表示
          lcd.print("ALT:");  //先頭の文字
          lcd.print(Altitude_ft/3.2808, 1);  //最後の「1」は小数点以下の桁数である。この0は表示しないということになる。
          
          lcd.setCursor(14, 1);  //14は先頭から13文字目から表示、2番目の1は2行目に表示
          lcd.print("km");
      }
      else{
          lcd.clear();
      }
     
  }
    
    //--------- loop内　i2C LCD1602 END ------------------------------------------------------------
    
    //--------- loop内 ロータリースイッチ ----------------
    //===============================================================================================
    /////////// loop内　CTR ロータリースイッチ（左側）//////////////////
    //===============================================================================================
    int CTR_RangeRotaryPos = getCTR_RangeRotaryValue();  //上で取得したスイッチの位置
 
    if( CTR_RangeRotaryPos == 1 ) {     //もしCTR_RangeRotaryPosが 1 なら   
    CTR_RangeSelector = 0;              //CTR_RangeSelectorを 0 の位置にする（X-Planeスイッチの左位置）
    } 
    if( CTR_RangeRotaryPos == 2 ) { 
    CTR_RangeSelector = 1;
    }     
    if( CTR_RangeRotaryPos == 3 ) { 
    CTR_RangeSelector = 2;
    }     
    if( CTR_RangeRotaryPos == 4 ) { 
    CTR_RangeSelector = 3;
    }
    //===============================================================================================
    /////////// loop内　TFC ロータリースイッチ（右側）//////////////////
    //===============================================================================================
    int TFC_RangeRotaryPos = getTFC_RangeRotaryValue();  
 
    if( TFC_RangeRotaryPos == 1 ) {  
    TFC_RangeSelector = 0;            
    } 
    if( TFC_RangeRotaryPos == 2 ) { 
    TFC_RangeSelector = 1;
    }     
    if( TFC_RangeRotaryPos == 3 ) { 
    TFC_RangeSelector = 2;
    }     
    if( TFC_RangeRotaryPos == 4 ) { 
    TFC_RangeSelector = 3;
    }
    if( TFC_RangeRotaryPos == 5 ) { 
    TFC_RangeSelector = 4;
    }
    if( TFC_RangeRotaryPos == 6 ) { 
    TFC_RangeSelector = 5;
    }
    if( TFC_RangeRotaryPos == 7 ) { 
    TFC_RangeSelector = 6;
    }
    if( TFC_RangeRotaryPos == 8 ) { 
    TFC_RangeSelector = 7;
    }
    //--------- loop内　ロータリースイッチ END ------------------------------------------------------------
    
    
    
    
    /////////////////////////////////////////////////////////////////////////
    //--- loop内　74HC595 LED シフトレジスタ ----------------------------
    /////////////////////////////////////////////////////////////////////////
    writeRegisters();  //ディスプレイの変更に呼ばれる必要があります。
                       //必要な値が設定された後に一度だけ呼び出す。
    
    //--------- loop内　74HC595 LED シフトレジスタ END ------------------------------------------------------------
    
    
    /////////////////////////////////////////////////////////////////////////
    //--- loop内　7セグメント ----------------------------
    ///////////////////////////////////////////////////////////////////////// 
    int status ;
    status = digitalRead(BUTTON) ; //スイッチの状態を読む

    modeSwitch_B1.update();
    modeSwitch_B2.update();
    modeSwitch_B3.update();
    
    // スイッチが押されたときにモードを変更する
    if(modeSwitch_B1.fallingEdge()) {
      ++mode_1;
      if(mode_1 >= Mode_Count_1)
        mode_1 = 0;
    }
    // スイッチが押されたときにモードを変更する
    if(modeSwitch_B2.fallingEdge()) {
      ++mode_2;
      if(mode_2 >= Mode_Count_2)
        mode_2 = 0;
    }
    // スイッチが押されたときにモードを変更する
    if(modeSwitch_B3.fallingEdge()) {
      ++mode_3;
      if(mode_3 >= Mode_Count_3)
        mode_3 = 0;
    }
    
    
    //light status LEDs
    //digitalWrite(Nav1_LED, (mode_1 == Mode_Nav1));
    //digitalWrite(Com1_LED, (mode_1 == Mode_Com1));
    
    if(status == HIGH) {  //ON/OFFトグルスイッチを押したときの処理
      if (mode_1 == Mode_Switch1) {  //mode_1はmodeSwitch_B1（左スイッチ）を押したときの最初のカウント
        setRegisterPin(12, HIGH);
        setRegisterPin(13, LOW);
        int Nav1_Val_keta1 = Nav1_Val % 10;  //例えば123の数字の場合、123÷10＝12.3で小数点以下の3が1桁の数字として表示
        int Nav1_Val_keta2 = Nav1_Val / 10 % 10 ;  //例えば123の数字の場合、、÷10＝12.3、さらに10で割って、1.23で小数点以下の2が表示
        int Nav1_Val_keta3 = Nav1_Val / 100 % 10;   //例えば123の数字の場合、123÷100＝1.23で1の整数が3桁目の数字として表示
        int Nav1_Val_keta4 = Nav1_Val / 1000 % 10;
        int Nav1_Val_keta5 = Nav1_Val / 10000 % 10;
        
        lc.setDigit(0, 0, Nav1_Val_keta1, false); //1桁目の値を表示、falseはドットを表示しない設定。
        lc.setDigit(0, 1, Nav1_Val_keta2, false); //2桁目の値を表示
        lc.setDigit(0, 2, Nav1_Val_keta3, true); //3桁目の値を表示
        lc.setDigit(0, 3, Nav1_Val_keta4, false); //3桁目の値を表示
        lc.setDigit(0, 4, Nav1_Val_keta5, false); //3桁目の値を表示
      }
      if (mode_2 == Mode_Switch2) {
        setRegisterPin(12, LOW);
        setRegisterPin(13, HIGH); 
        int Com1_Val_keta1 = Com1_Val % 10;  //例えば123の数字の場合、123÷10＝12.3で小数点以下の3が1桁の数字として表示
        int Com1_Val_keta2 = Com1_Val / 10 % 10 ;  //例えば123の数字の場合、、÷10＝12.3、さらに10で割って、1.23で小数点以下の2が表示
        int Com1_Val_keta3 = Com1_Val / 100 % 10;   //例えば123の数字の場合、123÷100＝1.23で1の整数が3桁目の数字として表示
        int Com1_Val_keta4 = Com1_Val / 1000 % 10;
        int Com1_Val_keta5 = Com1_Val / 10000 % 10;
        
        lc.setDigit(0, 0, Com1_Val_keta1, false); //1桁目の値を表示、falseはドットを表示しない設定。
        lc.setDigit(0, 1, Com1_Val_keta2, false); //2桁目の値を表示
        lc.setDigit(0, 2, Com1_Val_keta3, true); //3桁目の値を表示
        lc.setDigit(0, 3, Com1_Val_keta4, false); //3桁目の値を表示
        lc.setDigit(0, 4, Com1_Val_keta5, false); //3桁目の値を表示
      }
    }
    
    if(status == LOW) {   //ON/OFFトグルスイッチを押したときの処理
        setRegisterPin(12, HIGH);
        setRegisterPin(13, LOW);
        int Transponder_kts_keta1 = Transponder_Val % 10;  //例えば123の数字の場合、123÷10＝12.3で小数点以下の3が1桁の数字として表示
        int Transponder_kts_keta2 = Transponder_Val / 10 % 10 ;  //例えば123の数字の場合、、÷10＝12.3、さらに10で割って、1.23で小数点以下の2が表示
        int Transponder_kts_keta3 = Transponder_Val / 100 % 10;   //例えば123の数字の場合、123÷100＝1.23で1の整数が3桁目の数字として表示
        int Transponder_kts_keta4 = Transponder_Val / 1000 % 10;
        int Transponder_kts_keta5 = Transponder_Val / 10000 % 10;
        
        lc.setDigit(0, 0, Transponder_kts_keta1, false); //1桁目の値を表示、falseはドットを表示しない設定。
        lc.setDigit(0, 1, Transponder_kts_keta2, false); //2桁目の値を表示
        lc.setDigit(0, 2, Transponder_kts_keta3, false); //3桁目の値を表示
        lc.setDigit(0, 3, Transponder_kts_keta4, false); //3桁目の値を表示
        lc.setDigit(0, 4, Transponder_kts_keta5, false); //3桁目の値を表示 
     
  
    }

}
//loop END-------------



    //--------- 関数 ----------------  
    //--------- 関数 ロータリースイッチ ----------------
    //===============================================================================================
    /////////// 関数　CTR ロータリースイッチ //////////////////
    //===============================================================================================
    int getCTR_RangeRotaryValue() {  //ロータリースイッチの位置（つまりはピンの位置）を取得する
      for( int i=CTR_Rotary_firstPin; i<= CTR_Rotary_lastPin; i++) { //iは最初のピン、iは最後のピン以下の数になる、iにプラスしていく
        int val = digitalRead( i ); // ロータリースイッチのピンを読む
        if( val == LOW ) { // その読んだピンがLOWなら
        return (i - CTR_Rotary_firstPin + 1); // 5 - 1の範囲の値を返す
        }
      }
    return 0; // エラーの場合は0を返す
    }
    //===============================================================================================
    /////////// 関数　TFC ロータリースイッチ //////////////////
    //===============================================================================================
    int getTFC_RangeRotaryValue() {  //ロータリースイッチの位置（つまりはピンの位置）を取得する
      for( int i=TFC_Rotary_firstPin; i<= TFC_Rotary_lastPin; i++) { //iは最初のピン、iは最後のピン以下の数になる、iにプラスしていく
        int val = digitalRead( i ); // ロータリースイッチのピンを読む
        if( val == LOW ) { // その読んだピンがLOWなら
        return (i - TFC_Rotary_firstPin + 1); // 5 - 1の範囲の値を返す
        }
      }
    return 0; // エラーの場合は0を返す
    }
    //--------- 関数 ロータリースイッチ END ------------------------------------------------------------
  
    /////////////////////////////////////////////////////////////////////////
    //--- 関数　74HC595 LED シフトレジスタ 共通 ----------------------------
    /////////////////////////////////////////////////////////////////////////
    // すべてのレジスタの端子をLOWに設定
    void clearRegisters(){
      for(int i = numOfRegisterPins - 1; i >=  0; i--){
         registers[i] = LOW;
      }
    } 
     
    //Set and display registers
    //Only call AFTER all values are set how you would like (slow otherwise)
    //セットとディスプレイレジスタ
    //すべての値がご希望の方法を設定した後にのみ呼び出す（そうでないとくないとゆっくりになる）
    void writeRegisters(){
     
      digitalWrite(RCLK_latchPin, LOW);
     
      for(int i = numOfRegisterPins - 1; i >=  0; i--){
        digitalWrite(SRCLK_clockPin, LOW);
     
        int val = registers[i];
     
        digitalWrite(SER_dataPin, val);
        digitalWrite(SRCLK_clockPin, HIGH);
     
      }
      digitalWrite(RCLK_latchPin, HIGH);
     
    }
     
    //set an individual pin HIGH or LOW
    //個々のピンを高いか低いか設定
    void setRegisterPin(int index, int value){
      registers[index] = value;
    }
    //--------- 関数　74HC595 LED シフトレジスタ 共通 END ------------------------------------------------------------
    
    /////////////////////////////////////////////////////////////////////////
    //--- 関数　74HC595 LED シフトレジスタ ----------------------------
    /////////////////////////////////////////////////////////////////////////
    
    /////////// 関数 逆噴射 LED Lamp -----------
    void updateReverserSwLED(long value) {
        if (value == 1)  {
          setRegisterPin(Reverser_74HC595_Pin, HIGH);    //消灯
        } else {
          setRegisterPin(Reverser_74HC595_Pin, LOW);    //点灯
        }
      }

    /////////// 関数　スピードブレーキ LED シフトレジスタ（74HC595）-----------
    void updateSpeedBrakeSwLED(long value) {
      if (value == 0)  {
        setRegisterPin(SpeedBrake_74HC595_Pin, LOW);    //消灯
      } else {
        setRegisterPin(SpeedBrake_74HC595_Pin, HIGH);    //点灯
      }
    }

    /////////// 関数　パーキングブレーキ LED シフトレジスタ（74HC595）-----------
    void updateParkingBrakeSwLED(float value) {
      if (value > 0.289626)  {
        setRegisterPin(ParkingBrake_74HC595_Pin, HIGH);    //消灯
      } else {
        setRegisterPin(ParkingBrake_74HC595_Pin, LOW);    //点灯
      }
    }

    /////////// 関数　ギア LED シフトレジスタ（74HC595）-----------
    void updateGearHandoleLED(long value) {
      if (value == 0)  {
        setRegisterPin(GearHandole_74HC595_Pin, LOW);    //消灯
      } else {
        setRegisterPin(GearHandole_74HC595_Pin, HIGH);    //点灯
      }
    }

    /////////// 関数　ビーコン　ライト LED シフトレジスタ（74HC595）-----------
    void updateBeaconBrightnessLED(float value) {
      if (value == 1)  {                      //ビーコンは0.000000〜0.900000の間で明るさを調整してあるので複雑である。
        setRegisterPin(BeaconBrightness_74HC595_Pin, HIGH);    //点灯　ややタイミングずれている
      } else {
        setRegisterPin(BeaconBrightness_74HC595_Pin, LOW);    //消灯
      }
    }

    /////////// 関数　ストロボ　ライト LED シフトレジスタ（74HC595）-----------
    void updateStorobeLightLED(long value) {
      if (value == 1)  {
        setRegisterPin(StorobeLight_74HC595_Pin, HIGH);    //消灯
      } else {
        setRegisterPin(StorobeLight_74HC595_Pin, LOW);    //点灯
      }
    }

    /////////// 関数　ウイング　ライト LED シフトレジスタ（74HC595）-----------
    void updateWingLightLED(long value) {
      if (value == 1)  {
        setRegisterPin(WingLight_74HC595_Pin, HIGH);    //点灯
      } else {
        setRegisterPin(WingLight_74HC595_Pin, LOW);    //消灯
      }
    }

    /////////// 関数　ロゴ　ライト LED シフトレジスタ（74HC595）-----------
    void updateLogoLightLED(long value) {
      if (value == 1)  {
        setRegisterPin(LogoLight_74HC595_Pin, HIGH);    //点灯
      } else {
        setRegisterPin(LogoLight_74HC595_Pin, LOW);    //消灯
      }
    }

    /////////// 関数　ランディング　ライト LED シフトレジスタ（74HC595）-----------
    void updateLandingLight_RETRACTABLE_LED(long value) {
      if (value == 1)  {
        setRegisterPin(LandingLight_RETRACTABLE_74HC595_Pin, HIGH);    //点灯
      } else {
        setRegisterPin(LandingLight_RETRACTABLE_74HC595_Pin, LOW);    //消灯
      }
    }

    /////////// 関数　Taxi　ライト LED シフトレジスタ（74HC595）-----------
    void updateTaxiLightLED(float value) {
      if (value == 1)  {
        setRegisterPin(TaxiLight_74HC595_Pin, HIGH);    //点灯
      } else {
        setRegisterPin(TaxiLight_74HC595_Pin, LOW);    //消灯
      }
    }

    /////////// 関数　Runway Turnoff　ライト LED シフトレジスタ（74HC595）-----------
    void updateRunwayTurnoff_LeftLightLED(long value) {
      if (value == 1)  {
        setRegisterPin(RunwayTurnoff_Left_74HC595_Pin, HIGH);    //点灯
      } else {
        setRegisterPin(RunwayTurnoff_Left_74HC595_Pin, LOW);    //消灯
      }
    }
    void updateRunwayTurnoff_RightLightLED(long value) {
      if (value == 1)  {
        setRegisterPin(RunwayTurnoff_Right_74HC595_Pin, HIGH);    //点灯
      } else {
        setRegisterPin(RunwayTurnoff_Right_74HC595_Pin, LOW);    //消灯
      }
    }
    
    //--------- 関数　74HC595 LED シフトレジスタ END ------------------------------------------------------------
 
    void updateNav1_Val(long value) {
      if (value == HIGH)  {
        //setRegisterPin(LeftLED_74HC595_Pin, HIGH);    //点灯
      } else {
        //setRegisterPin(LeftLED_74HC595_Pin, LOW);    //消灯
      }
    }
    void updateCom1_Val(long value) {
      if (value == HIGH)  {
        //setRegisterPin(RightLED_74HC595_Pin, HIGH);    //点灯
      } else {
        //setRegisterPin(RightLED_74HC595_Pin, LOW);    //消灯
      }
    }

    
